//-------------------------------------------------------------------------------------//
//:          max30102Գ                  
//汾:            V1.0                        
//:            2016/11/14                       
//д:          Ƽ               
//վ:            www.wx-rcwl.com
//أ       http://pan.baidu.com/s/1miNGWha
//:            max30102ID¶Ȳֹܡ
//-------------------------------------------------------------------------------------//
//RCWL-0530ģ51ӿӣ
// 1VCC   --   1.8V-5.5VԴ 
// 2SCL   --   P3.5
// 3SDA   --   P3.7
// 4INT   --   NC
// 5IRD   --   NC
// 6RD    --   NC
// 7GND   --   
//-------------------------------------------------------------------------------------//
# include <reg52.h>
# include <stdio.h>
# include <intrins.h>
//IICӿ
sbit IIC_SCL    =P3^5;     //IICSCL
sbit IIC_SDA    =P3^7;     //IICSDA
bit  IIC_ACK;              //IICACK
int  rda;                  //IIC
//-------------------------------------------------------------------------------------//
//:    delayms()
//:    ʱ
//-------------------------------------------------------------------------------------//
void delayms(unsigned int ms)
{
	unsigned char i=100,j;
	for(;ms;ms--)
	{
		while(--i)
		{
			j=10;
			while(--j);
		}
	}
}
//-------------------------------------------------------------------------------------//
//:    void iic_start();
//:    I2C߿ʼ
//-------------------------------------------------------------------------------------//
//   SCL   --- --- ___
//   SDA   --- ___ ___
void iic_start()
{  
IIC_SDA=1;
_nop_();
_nop_();
IIC_SCL=1;         
_nop_();
_nop_();
IIC_SDA=0;
_nop_();
_nop_();
IIC_SCL=0;
_nop_();
_nop_();
}
//-------------------------------------------------------------------------------------//
//:    void iic_stop();
//:    I2C߽
//趨壺
//-------------------------------------------------------------------------------------//
//   SCL   ___ --- ---
//   SDA   ___ ___ ---
void iic_stop()
{  
IIC_SCL=0;
_nop_();
_nop_();
IIC_SDA=0;
_nop_();
_nop_();
IIC_SCL=1;
_nop_();
_nop_();
IIC_SDA=1;
_nop_();
_nop_();
}
//-------------------------------------------------------------------------------------//
//:    void iic_sendbyte(unsigned char c);
//:     8_BIT 
//-------------------------------------------------------------------------------------//
void iic_sendbyte(unsigned char c)
{
unsigned char bitcnt;
for(bitcnt=0;bitcnt<8;bitcnt++)
{
if((c<<bitcnt)&0x80)
 IIC_SDA=1;
else
 IIC_SDA=0;
_nop_();
_nop_();
IIC_SCL=1;
_nop_();
_nop_();
IIC_SCL=0;
}
_nop_();
_nop_();
IIC_SDA=1;
_nop_();
_nop_();
IIC_SCL=1;
_nop_();
_nop_();
if(IIC_SDA==0)
 IIC_ACK=0;
else
 IIC_ACK=1;
IIC_SCL=0;
_nop_();
_nop_();
}
//-------------------------------------------------------------------------------------//
//:    int iic_rcvbyte_nack();
//:     8_BIT   ackź
//-------------------------------------------------------------------------------------//
int iic_rcvbyte_nack()
{
unsigned char retc;
unsigned char bitcnt;
retc=0;
IIC_SDA=1;
for(bitcnt=0;bitcnt<8;bitcnt++)
{
_nop_();
_nop_();
IIC_SCL=0;
_nop_();
_nop_();
IIC_SCL=1;
_nop_();
_nop_();
retc=retc<<1;
if(IIC_SDA==1)
retc=retc+1;
_nop_();
_nop_();
}
//NACKź
_nop_();
_nop_();
IIC_SCL=0;
_nop_();
_nop_();
IIC_SDA=1;
_nop_();
_nop_();
IIC_SCL=1;
_nop_();
_nop_();
IIC_SCL=0;
_nop_();
_nop_();
return(retc);
}
//-------------------------------------------------------------------------------------//
//:    int iic_rcvbyte_ack();
//:     8_BIT  ackź
//-------------------------------------------------------------------------------------//
int iic_rcvbyte_ack()
{
unsigned char retc;
unsigned char bitcnt;
retc=0;
IIC_SDA=1;
for(bitcnt=0;bitcnt<8;bitcnt++)
{
_nop_();
_nop_();
IIC_SCL=0;
_nop_();
_nop_();
IIC_SCL=1;
_nop_();
_nop_();
retc=retc<<1;
if(IIC_SDA==1)
retc=retc+1;
_nop_();
_nop_();
}
//ACKź
_nop_();
_nop_();
IIC_SCL=0;
_nop_();
_nop_();
IIC_SDA=0;
_nop_();
_nop_();
IIC_SCL=1;
_nop_();
_nop_();
IIC_SCL=0;
_nop_();
_nop_();
return(retc);
}
//-------------------------------------------------------------------------------------//
//:      wr_max30102_one_data()
//:      дһλmax30102
//address:   оƬӵַ
//saddress:  дĴַ
//w_data:    д
//-------------------------------------------------------------------------------------//
void wr_max30102_one_data(int address,int saddress,int w_data )
{
_nop_();
iic_start();
_nop_();
iic_sendbyte(address);
_nop_();
iic_sendbyte(saddress);
_nop_();
iic_sendbyte(w_data);
_nop_();
iic_stop();
_nop_();
}
//-------------------------------------------------------------------------------------//
//:      rd_max30102_one_data()
//:      һλmax30102
//address:   оƬӵַ
//saddress:  Ĵַ
//rda:       
//-------------------------------------------------------------------------------------//
void rd_max30102_one_data(int address,int saddress)
{
iic_start();
_nop_();
iic_sendbyte(address);
_nop_();
iic_sendbyte(saddress);
_nop_();
address=address+1;
_nop_();
iic_start();
_nop_();
iic_sendbyte(address);
_nop_();
rda=iic_rcvbyte_nack();
_nop_();
iic_stop();
}
//-------------------------------------------------------------------------------------//
//:      
//:      max30102ڲ¶
//-------------------------------------------------------------------------------------//
main()
{
double temp,temp1,temp2;
//temp       ¶
//temp1      30100¶
//temp2      30100С¶
TMOD=0x21;		  
SCON=0x50;
TH1=0xFD;
TL1=0xFD;
TR1=1;			   
TI=1;   
//51ĲΪ 9600 N 8 1
//51ƵΪ11.0592MHz

while(1)
{
//λMAX30102
wr_max30102_one_data(0xae,0x09,0x0b);     
//оƬID
rd_max30102_one_data(0xae,0xff);            // оƬID
printf("max30102 ID =%d\n",rda);            // ʾ
//LED
wr_max30102_one_data(0xae,0x08,0x43);       // LEDLED
//оƬ¶ȹܼ
wr_max30102_one_data(0xae,0x21,0x01);       // 0X21ַB0λTEMP_EN1
delayms(50);                                // ȴ¶תɣȴ
rd_max30102_one_data(0xae,0x1F);            // ¶ź
printf("temp1=%d\n",rda);                   // ʾ
temp1=rda;
rd_max30102_one_data(0xae,0x20);            // ¶С
printf("temp2=%d\n",rda);                   // ʾ
temp2=rda;
temp=temp1+(temp2*0.0625);                  // ¶ȣССֵ0.0625
printf("ǰ¶=%.4f\n",temp);             // ʾǰ¶
delayms(100);   
printf("\n");                               // 
}
}